
; frame is 3 vectors
; casa is cos and sine of the rotation angle

        ;.macro getsine index , sine
        ;iaddiu temp, vi00, index
        ;iaddiu iMask, vi00, H'001f
        ;iand temp,iMask
	;;ibne temp, OVER_LIMIT
        ;lq \sine,  
;        xindex
;        lq xangle
;OVER_LIMIT:
	
        .macro rotateX	frame, casa
        move temp, \frame[1] ;you were overwriting original Y 
        mulax acc,\frame[1],\casa 		;acc=Y*ca
	maddy \frame[1], \frame[2],\casa 	;Y=Y*ca+Z*sa
        mulax acc, \frame[2],\casa		;acc=Z*ca
	msuby \frame[2], temp,\casa	        ;Z=Z*ca-Y*sa
	.endm

        .macro rotateY	frame, casa
	move temp, \frame[0]	
	mulax acc,\frame[0],\casa               ;acc=X*ca
	maddy \frame[0],\frame[2],\casa         ;X=X*ca+Z*sa
	mulax acc, \frame[2],\casa              ;acc=Z*ca
	msuby \frame[2],temp,\casa              ;Z=Z*ca-X*sa
	.endm

        .macro rotateYt	frame, casa
        mulx frame0cos, \frame[0], \casa
	muly frame0sin, \frame[0], \casa
	mulx frame1cos, \frame[1], \casa
	muly frame1sin, \frame[1], \casa
	mulx frame2cos, \frame[2], \casa
	muly frame2sin, \frame[2], \casa
	
	addz.x \frame[0], frame0cos ,frame0sin
	addz.x \frame[1], frame1cos ,frame1sin
	addz.x \frame[2], frame2cos ,frame2sin
	subx.z \frame[0], frame0cos ,frame0sin
	subx.z \frame[1], frame1cos ,frame1sin
	subx.z \frame[2], frame2cos ,frame2sin
	.endm

        .macro rotateXt	frame, casa
        mulx frame0cos, \frame[0], \casa
	muly frame0sin, \frame[0], \casa
	mulx frame1cos, \frame[1], \casa
	muly frame1sin, \frame[1], \casa
	mulx frame2cos, \frame[2], \casa
	muly frame2sin, \frame[2], \casa
	
	addz.y \frame[0], frame0cos ,frame0sin
	addz.y \frame[1], frame1cos ,frame1sin
	addz.y \frame[2], frame2cos ,frame2sin
	suby.z \frame[0], frame0cos ,frame0sin
	suby.z \frame[1], frame1cos ,frame1sin
	suby.z \frame[2], frame2cos ,frame2sin
	.endm


	.macro normalise frame
	erleng p, \frame[2]
	mfp temp,p
	mul \frame[2],\frame[2], temp
	opmula.xyz acc, \frame[0], \frame[2]
	opmsub.xyz \frame[1], \frame[2], \frame[0]
	erleng p, \frame[1]
	mfp temp,p
	mul \frame[1], \frame[1],temp
	opmula.xyz acc, \frame[2], \frame[1]
	opmsub.xyz \frame[0], \frame[1], \frame[2]
	.endm


	.macro setDepth ascale ,abias    
	loi 0.01
	muli near, vf00, i
	loi 100.0
	muli far, vf00, i
	sub below, far, near
	add above, far, near
	div q, vf00[w],below[w]
	mulq \ascale, above, q
	mul above, far, near
	loi 2.0
	muli above, above, i
	mulq \abias, above, q
	.endm

	;.macro newVel  dv, oldv, newv    
	;loi 1.0
        ;add.x k, vf00, i
	;mul.x v2, \oldv, \oldv
        ;sub.x k, k, v2
        ;div q, vf00[w],k[x]
        ;mulq ,k   
	;muli near, vf00, i
	;loi 100.0
	;muli far, vf00, i
	;sub below, far, near
	;add above, far, near
	;div q, vf00[w],below[w]
	;mulq \ascale, above, q
	;mul above, far, near
	;loi 2.0
	;muli above, above, i
	;mulq \abias, above, q
	;.endm

       
