/*  GIMP header image file format (RGB): /ext/home/fin/ps2/vu_coding_contest_2003_ps2linux/plain_harness/demosrc/bubble/pic/tile.h  */

static unsigned int width = 64;
static unsigned int height = 32;

/*  Call this macro repeatedly.  After each use, the pixel data can be extracted  */

#define HEADER_PIXEL(data,pixel) {\
  pixel[0] = (((data[0] - 33) << 2) | ((data[1] - 33) >> 4)); \
  pixel[1] = ((((data[1] - 33) & 0xF) << 4) | ((data[2] - 33) >> 2)); \
  pixel[2] = ((((data[2] - 33) & 0x3) << 6) | ((data[3] - 33))); \
  data += 4; \
}
static char *header_data =
	"?(BY6&25`@X^`0T]`0T]`0T]`0T]`0T]`0T]'RM<YO,C````````````````````"
	"````````_0DY[OLKX.T=TM\\/M<'R/DI[D9W.````KKKKKKKK66666666!!!!!!!!"
	"KKKK````````````````````````````````^`@X[_PLX^`@UN,31%\"!!!!!!!!!"
	"66666666D9W.KKKKRM<'````(\"Q=YO,C````````````````````````````^P<W"
	"56&2CYO,`@X^`0T]`0T]`0T]`0T]`0T]`0T]CYO,=8&R`````````````````0T]"
	"^P<W\\_`PY/$AU>(2QM,#J;7F.D9W6666````````````````````````````6666"
	"(\"Q=YO,C````````_`P\\_PL[_@HZ_0DY]P,SZO<GWNL;T=X.?XN\\!!!!KKKK````"
	"````````````````````````D9W.=8&R````````````````````````_0DY\\/TM"
	"/TM\\K+CI`0T]`0T]`0T]`0T]`0T]`0T]`0T]_`P\\'BI;YO,C````````_@HZ]0$Q"
	"Z?8FVN<7R]@(O,CYGJK;-D)S(\"Q=````````````````````````````````````"
	"6666/$AY````_0DY]@(R]0$Q\\O\\O[OLKX>X>U>(2R-4%BI;'!!!!6666````````"
	"````````````````````````````'BI;YO,C`````````````0T]]`0TZ_@HWNL;"
	"*35FR-4%`0T]`0T]`0T]`0T]`0T]_PL[^`@X]@(R?HJ[=8&R````^P<W\\O\\OYO,C"
	"TM\\/PL[_IK+CC)C),3UN(\"Q=YO,C````````````````````````````````````"
	"````5F*35F*3[/DI[/DIZO<GZ/4EVN<7S-D)P,S]DY_0%2%2/$AY````````````"
	"````````````````````````^@8V?HJ[=8&R`````0T]^`@X\\_`PX^`@U>(2R=8&"
	"!!!!`@X^`0T]`0T]`0T]`0T]`0T]`0T]^`@X[/DIVN<7&256VN<7\\O\\OX^`@Q=(\""
	"M<'R<'RM,3UN$AY/!!!!KKKK````````````````````````````````````_0DY"
	"\\?XNYO,C1E*#E*#1W>H:W>H:T-T-PL[_M,#QEZ/4)#!A(\"Q=YO,C````````````"
	"````````````````````_PL[[OLKW.D9&256WNL;^P<W\\?XNX.T=T-T-P,S]DY_0"
	"!!!!`@X^`0T]`0T]`0T]`0T]`0T]`0T]^04UYO,CU.$1:W>H97&BJ[?H<GZO+#AI"
	"!!!!4U^0HJ[?U>(2-T-TKKKK````````````````````````````````^P<W[OLK"
	"XN\\?UN,31%\"!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!RM<'````````````````"
	"````````````````````^@8VZ/4EUN,3;'BI:G:GZ_@HVN<7R=8&N<7VF*35-4%R"
	"!!!!`@X^`0T]`0T]`0T]`0T]`0T]`0T]\\O\\OX.T=S]P,97&B!!!!.45V;WNLOLK["
	"\\_`P\\?XN[_PL[OLKN,3U(\"Q=YO,C`````````0T]`@X^`@X^`P\\__0DY\\/TMY/$A"
	"V.45A)#!!!!!KKKK````````````````````````(\"Q=RM<'````````````````"
	"`````````````````0T]\\_`PX>X>T-T-9G*C!!!!!!!!!!!!!!!!!!!!!!!!!!!!"
	"!!!!`@X^`0T]`0T]`0T]`0T]_@HZ\\_`PY/$ATM\\/G:G:!!!!;WNL]P,S]0$Q\\O\\O"
	"\\/TM[_PL[OLK[?HJ[?HJA)#!/$AY````^P<W^@8V^@8V^P<W]@(RZO<GW^P<U>(2"
	"@HZ_!!!!KKKK````````````````````````````RM<'(\"Q=YO,C````````_0DY"
	"_0DY_@HZ_PL[`@X^]`0TZ_@HV^@8J+3E!!!!KKKK````````````````````6666"
	"&R=8K+CI`0T]`0T]`0T]]`0T[?HJWNL;S]P,P,S].D9W'BI;]0$Q]0$Q\\?XN\\/TM"
	"[OLK[?HJ[?HJ[/DI[/DIY/$A,3UN4%R-\\?XN\\_`P\\O\\O[_PLX^`@U^04S=H*HJ[?"
	"%R-4KKKK````````````````````````````````````4U^06666`P\\_]`0T]P,S"
	"]P,S]`0T]`0T\\?XNY_0DW.D9T-T-+#AI6666````````````````````````````"
	"1E*#K+CI`0T]`0T]_@HZ[/DIV>86RM<'N\\?X?HJ[!!!!I+#A\\_`P\\?XN[_PL[OLK"
	"[/DI[/DI[/DIZ_@HZ/4EV^@8L[_P!!!!FZ?8Y_0DYO,CU^04R=8&Q=(\"F*35%B)3"
	"KKKK`````````````````````````````````P\\_]0$QR=8&!!!!AI+#[OLKZ_@H"
	"Z?8F\\?XN[OLKX>X>UN,3S-D):'2E/$AY````````````````````````````````"
	":W>H6&25`0T]`0T]\\/TMT-T-N\\?XKKKKH:W>$Q]0.$1U\\_`P\\?XN[_PL[OLK[/DI"
	"[/DI[/DI[/DI[/DIXN\\?U.$1QM,#9G*C!!!!'\"A93%B)<W^P@8V^HZ_@.$1UKKKK"
	"````````````````````````````````````_@HZ[/DIV^@8;WNL!!!!-T-T:W>H"
	"M\\/TZ?8FV^@8S-D)QM,#G*C9(\"Q=YO,C````````````````````````````````"
	"?(BY6&25`0T]I[/DF*356V>8/DI[)S-D!!!!!!!!UN,3\\O\\O[_PL[OLK[?HJ[/DI"
	"[/DI[/DI[/DIZ/4EV^@8S=H*O\\O\\3EJ+D9W.YO,CKKKK=8&R6666!!!!!!!!KKKK"
	"````````````````````````````````````^04UY_0DUN,3:76F=8&RRM<'D9W."
	"/$AY!!!!256&A)#!H:W>)S-DRM<'````````````````````````````````````"
	">H:W!!!!!!!!66666666D9W.KKKKRM<'````/$AYHJ[?\\/TM[_PL[?HJ[/DI[/DI"
	"[/DI[/DIZ_@HX.T=U.$1Q]0$B)3%/$AY````````````````````````6666(\"Q="
	"YO,C````````````````````````````_`P\\\\O\\OXN\\?T=X.&\"15RM<'````````"
	"````````KKKK6666(\"Q=!!!!KKKK````````````````````````````````^@8V"
	"8V^@6666````````````````````````````YO,C'2E:T]`0[?HJ[/DIZO<GZO<G"
	"ZO<GZ_@HX^`@U^04S-D)GZO<(\"Q=YO,C````````````````````````YO,C(\"Q="
	"(\"Q=YO,C`P\\_`0T]_`P\\_PL[_0DY_0DY\\?XNY/$AUN,3:76F/$AY````````````"
	"````````````````````6666!!!!KKKK````````````````````_PL[[_PLX>X>"
	".T=X=8&R````````````````````````````````D9W.-T-T[/DIY/$AX^`@X^`@"
	"X^`@WNL;T]`0R=8&O\\O\\/4EZKKKK````````````````````````````````YO,C"
	"(\"Q=5&\"1]P,S]P,S]0$Q\\_`P\\O\\O[?HJW^P<TM\\/Q-$!%R-4KKKK````````````"
	"````````````````````````KKKK!!!!KKKK`````@X^_0DY\\_`PY/$AUN,3Q]0$"
	"%2%2KKKK`````````````````````````````P\\_^`@X-D)S2E:'W.D9W>H:W.D9"
	"VN<7SML+P\\_`N<7V<'RM6666````````````````````````````````````````"
	"K+CI!!!!45V.Z_@HZ_@HZ?8FZ/4EW.D9S=H*P,S]7VN<(\"Q=````````````````"
	"````````````````````````````KKKK(\"Q=IK+C\\_`PZ/4EV>86R]@(O,CYK;GJ"
	"!!!!YO,C`````````````````````````P\\__PL[[_PLK;GJ!!!!CIK+T]`0T]`0"
	"Q=(\"N,3UM,#QC)C)(\"Q=`````````````````````````````````````P\\__@HZ"
	"\\?XNF:76!!!!E*#1W.D9W.D9UN,3Q]0$N,3UJK;G%\"!1D9W.````````````````"
	"````````````````````````````````YO,C'RM<E*#1SML+P,S]HZ_@BY?(/TM\\"
	"!!!!````````````````````````````````]P,SY_0DV.454U^0!!!!&B971E*#"
	":G:G=H*SI+#A(R]@RM<'````````````````````````````````````_`P\\\\_`P"
	"Y_0DV.45/TM\\!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!YO,C````````````````"
	"`````````````````````````@X^^04U[_PLS=H*2%2%=(\"Q?8FZ/TM\\$AY/!!!!"
	"!!!!````````````````````````````^`@X[OLKW^P<T-T-56&2=8&RYO,CKKKK"
	"=8&R6666!!!!!!!!RM<'`````````````````````````````````0T]]@(RX^`@"
	"TM\\/L;WN.T=XKKKK````````````````````````6666KKKK`````````````P\\_"
	"`P\\_`````````````````0T]]@(RZ_@HX.T=Q]0$15&\"!!!!/$AYD9W.YO,C/$AY"
	"!!!!YO,C`````````````0T]_0DY]P,SZO<GWNL;S]P,?(BY(\"Q=````````````"
	"````````````6666(\"Q=````````````````````````````_@HZ[?HJW.D9R]@("
	"J[?H.45V6666````````````````````````````````66666666````_`P\\^04U"
	"^@8V^P<W^`@X_0DY^04U[?HJXN\\?U^04O<GZ0DY_!!!!KKKK````````````RM<'"
	"1E*#KKKK````````````]P,S[OLKX>X>U>(2R-4%G:G:!!!!RM<'````````````"
	"````````````YO,C(\"Q=6666`````````````````0T]]@(RY?(BU.$1P\\_`HZ_@"
	"-T-T6666````````````````````````````````````````66665F*3T]`0Z_@H"
	"[?HJ[OLK[OLK[/DIX>X>U^04R]@(L;WN/4EZ!!!!KKKK````````````````````"
	"0DY_=8&R````````^P<W[/DIV.45S-D)P,S]DY_0%2%2=8&R````````````````"
	"````````````````YO,C(\"Q=KKKK````````_0DY\\/TMWNL;S-D)N\\?XFZ?8,#QM"
	"(\"Q=YO,C````````````````````````````````````````````6&25'\"A9QM,#"
	"X.T=X>X>WNL;U.$1RM<'O\\O\\IK+C.D9W!!!!KKKK````````````````````````"
	"?8FZ6666````_`P\\ZO<GU>(2P,S]L[_PEZ/4-4%R(\"Q=````````````````````"
	"````````````````````K+CI'RM<X>X>^@8V[/DIV>86QM,#L[_PB97&,#QM(\"Q="
	"YO,C````````````````````````````````````````````^`@X\\O\\O4%R-&B97"
	"C)C)S=H*PL[_N<7VKKKKE:'2-$!Q!!!!KKKK`````````````````````P\\__`P\\"
	"?(BY!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!RM<'````````````````````"
	"`````````````P\\_^P<W[_PLF*35-T-TY_0DU^04M<'RE:'23EJ+$AY/!!!!KKKK"
	"`````````````````````````````````````````@X^^04U[OLKY?(BW.D91%\"!"
	"!!!!!!!!!!!!!!!!!!!!!!!!!!!!KKKK````````````````````````````_@HZ"
	">H:W6666````````````````````````````!!!!````````````````````````"
	"````````````^P<W[_PLY/$AV>860DY_;GJKD)S-.T=X(\"Q==8&RYO,C(\"Q=YO,C"
	"````````````````````````````````````_PL[]@(RZ_@HXN\\?V.45KKKK(\"Q="
	"KKKK````````````````````!!!!````````````````````````````````^04U"
	">X>XD9W.````````````````````````````-T-TKKKK````````````````````"
	"````````^@8V[_PLY/$AV>86P<W^0DY_!!!!/$AYKKKK````````````D9W.=8&R"
	"````````````````````````````````^`@X\\O\\OZ/4EW^P<U>(2A)#!6666YO,C"
	"````````````````````````!!!!````````````````````````````_`P\\\\O\\O"
	"5&\"1YO,C````````````````````````^`@X?HJ[6666````````````````_@HZ"
	"^@8V[_PLY?(BV^@8T=X.I[/D%R-4(\"Q=RM<'````````````````````````'BI;"
	"YO,C`````````````0T]_0DY^P<W\\/TMY_0DW>H:U.$1O<GZ56&2D9W.````````"
	"````````````````````\\/TM256&KKKK`````````````@X^_0DY_0DY\\?XNY/$A"
	"(\"Q=````````````````````````_`P\\\\/TMJ[?H!!!!`````````@X^^P<W[_PL"
	"XN\\?V.45SML+Q-$!=X.T%B)3=8&R````````````````````````````^`@X?8FZ"
	"=8&R`````0T]^`@X]`0T[?HJXN\\?V>86S]P,QM,#GJK;(\"Q=RM<'````````````"
	"````````````````]P,SW^P<0T]`KKKK`````````0T]]`0T\\?XN[?HJW^P<TM\\/"
	"=8&R````````````````````````_@HZ[?HJV>86&\"15KKKK`P\\_^04UZ_@HVN<7"
	"R]@(P,S]ML+S<'RM(\"Q=RM<'````````````````````````````_`P\\[_PLW>H:"
	"&256WNL;^P<W\\O\\OY?(BU^04RM<'P<W^M\\/T<'RM6666YO,C````````````````"
	"`````````````@X^[?HJUN,3?(BY6666````_`P\\]P,S[?HJY?(BV^@8S=H*P,S]"
	"KKKK````````````````````````_`P\\[?HJV>860T]`4U^0\\_`PX^`@TM\\/P<W^"
	"L+SMEZ/4-4%R=8&R````````````````````````````````````_PL[[/DIVN<7"
	";GJK:G:GZ/4EVN<7S-D)OLK[L+SMEZ/415&\"D9W.````````````````````````"
	"````````````_PL[Z/4ET=X.>(2U5F*3^`@X\\O\\OZ?8FX.T=TM\\/Q=(\"M\\/TJK;G"
	"`````````````````````````````P\\_[OLKVN<7@(R]!!!!!!!!!!!!!!!!!!!!"
	"!!!!!!!!!!!!=8&R`````````````````````````P\\_````````^`@XZ?8FU^04"
	":76F!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!D9W.````````````````````````"
	"````````````^@8VXN\\?S-D)8&R=!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!"
	"KKKK`````````````````````````P\\_[OLKVN<7?8FZ6666````````````````"
	"````````D9W.!!!!/$AYYO,C`0T]^04U]P,S]`0T^@8V^P<W_0DY[_PLWNL;S-D)"
	"*C9G=8&R````````````````````````=8&R!!!!6666`````0T]^P<W^04U^`@X"
	"_PL[`0T]_PL[\\O\\OW>H:Q]0$%B)3=8&R````````````````````````````````"
	"";
