.macro UploadTextureRandom lUseNumber
  iaddiu _STRiAddress, vi00, k256_QWORDS
  iaddiu _STRiAddress, _STRiAddress, 1
  iaddiu _STRiLooper, vi00, 0
  iaddiu _STRiCheck, vi00, 1024
  sub _STRfColor, vf00, vf00
  loi 128
  add.w _STRfColor, _STRfColor, i
  ftoi0.w _STRfColor, _STRfColor 
  loi 256

_STRlLoopHere\lUseNumber:
  mfir.xyzw _STRfColorTemp, _STRiLooper
  rnext.x _STRfColorTemp, R
  rnext.y _STRfColorTemp, R
  rnext.z _STRfColorTemp, R
  rnext.w _STRfColorTemp, R
  itof0 _STRfColorRGBW, _STRfColorTemp
  mul.yz _STRfColorRGBW, _STRfColorRGBW, i
  mul.z _STRfColorRGBW, _STRfColorRGBW, i
  add.w _STRfColorRGBW, _STRfColorRGBW, _STRfColorRGBW[y]
  add.w _STRfColorRGBW, _STRfColorRGBW, _STRfColorRGBW[z]
  ftoi0 _STRfColor, _STRfColorRGBW

  rnext.x _STRfColor, R
  rnext.y _STRfColor, R
  rnext.z _STRfColor, R
  rnext.w _STRfColor, R

  sqi _STRfColor, (_STRiAddress++)

  iaddiu _STRiLooper, _STRiLooper, 4
  ibne _STRiLooper, _STRiCheck, _STRlLoopHere\lUseNumber

  lq _STRfBitBltBuf, kTEXTURE_UPLOAD_INIT_BITBLTBUF_TEMPLATE(vi00)
  sq _STRfBitBltBuf, kTEXTURE_UPLOAD_INIT_BITBLTBUF(vi00)

  ilw.y _STRiTargetPageCurrent, kTEXTURE_UPLOAD_INIT_BITBLTBUF(vi00)
  ilw.y _STRiTargetPageOffset, 1023(vi00)
  iadd _STRiTargetPageOffset, _STRiTargetPageOffset, _STRiTargetPageOffset
  iadd _STRiTargetPageOffset, _STRiTargetPageOffset, _STRiTargetPageOffset
  iadd _STRiTargetPageOffset, _STRiTargetPageOffset, _STRiTargetPageOffset
  iadd _STRiTargetPageOffset, _STRiTargetPageOffset, _STRiTargetPageOffset
  iadd _STRiTargetPageOffset, _STRiTargetPageOffset, _STRiTargetPageOffset
  iadd _STRiTargetPage, _STRiTargetPageCurrent, _STRiTargetPageOffset
  isw.y _STRiTargetPage, kTEXTURE_UPLOAD_INIT_BITBLTBUF(vi00)

  KICK kTEXTURE_UPLOAD_INIT
  lq _STRfTag, kGIF_TAG_IMAGE(vi00)
  sq _STRfTag, k256_QWORDS(vi00)
  ilw.x _STRiNLoop, k256_QWORDS(vi00)
  iaddiu _STRiNLoop, _STRiNLoop, 256
  isw.x _STRiNLoop, k256_QWORDS(vi00)

  KICK k256_QWORDS
  KICK kTEXTURE_ENABLE
.endm

.macro UploadTexturePattern lUseNumber
  iaddiu _STPiAddress, vi00, k256_QWORDS
  iaddiu _STPiAddress, _STPiAddress, 1
  iaddiu _STPiLooper, vi00, 0
  iaddiu _STPiCheck, vi00, 1024
  sub _STPfColor, vf00, vf00
  loi 128
  add.w _STPfColor, _STPfColor, i
  ftoi0.w _STPfColor, _STPfColor 
  loi 256

_STPlLoopHere\lUseNumber:
  mfir.xyzw _STPfColorTemp, _STPiLooper
  itof0 _STPfColorRGBW, _STPfColorTemp
  mul.yz _STPfColorRGBW, _STPfColorRGBW, i
  mul.z _STPfColorRGBW, _STPfColorRGBW, i
  add.w _STPfColorRGBW, _STPfColorRGBW, _STPfColorRGBW[y]
  add.w _STPfColorRGBW, _STPfColorRGBW, _STPfColorRGBW[z]
  ftoi0 _STPfColor, _STPfColorRGBW

  sqi _STPfColor, (_STPiAddress++)

  iaddiu _STPiLooper, _STPiLooper, 4
  ibne _STPiLooper, _STPiCheck, _STPlLoopHere\lUseNumber

  lq _STPfBitBltBuf, kTEXTURE_UPLOAD_INIT_BITBLTBUF_TEMPLATE(vi00)
  sq _STPfBitBltBuf, kTEXTURE_UPLOAD_INIT_BITBLTBUF(vi00)

  ilw.y _STPiTargetPageCurrent, kTEXTURE_UPLOAD_INIT_BITBLTBUF(vi00)
  ilw.y _STPiTargetPageOffset, 1023(vi00)
  iadd _STPiTargetPageOffset, _STPiTargetPageOffset, _STPiTargetPageOffset
  iadd _STPiTargetPageOffset, _STPiTargetPageOffset, _STPiTargetPageOffset
  iadd _STPiTargetPageOffset, _STPiTargetPageOffset, _STPiTargetPageOffset
  iadd _STPiTargetPageOffset, _STPiTargetPageOffset, _STPiTargetPageOffset
  iadd _STPiTargetPageOffset, _STPiTargetPageOffset, _STPiTargetPageOffset
  iadd _STPiTargetPage, _STPiTargetPageCurrent, _STPiTargetPageOffset
  isw.y _STPiTargetPage, kTEXTURE_UPLOAD_INIT_BITBLTBUF(vi00)

  KICK kTEXTURE_UPLOAD_INIT
  lq _STPfTag, kGIF_TAG_IMAGE(vi00)
  sq _STPfTag, k256_QWORDS(vi00)
  ilw.x _STPiNLoop, k256_QWORDS(vi00)
  iaddiu _STPiNLoop, _STPiNLoop, 256
  isw.x _STPiNLoop, k256_QWORDS(vi00)

  KICK k256_QWORDS
  KICK kTEXTURE_ENABLE
.endm
