#include "geommath.h"

#define NUM_VERTS 36

Vec4 texts[NUM_VERTS] = {	Vec3(0.0f,0.0f,1.0f),
							Vec3(1.0f,0.0f,1.0f),
							Vec3(0.0f,1.0f,1.0f),
							Vec3(1.0f,1.0f,1.0f),
							Vec3(0.0f,1.0f,1.0f),
							Vec3(1.0f,0.0f,1.0f),

							Vec3(0.0f,0.0f,1.0f),
							Vec3(1.0f,0.0f,1.0f),
							Vec3(0.0f,1.0f,1.0f),
							Vec3(1.0f,1.0f,1.0f),
							Vec3(0.0f,1.0f,1.0f),
							Vec3(1.0f,0.0f,1.0f),

							Vec3(0.0f,0.0f,1.0f),
							Vec3(1.0f,0.0f,1.0f),
							Vec3(0.0f,1.0f,1.0f),
							Vec3(1.0f,1.0f,1.0f),
							Vec3(0.0f,1.0f,1.0f),
							Vec3(1.0f,0.0f,1.0f),

							Vec3(0.0f,0.0f,1.0f),
							Vec3(1.0f,0.0f,1.0f),
							Vec3(0.0f,1.0f,1.0f),
							Vec3(1.0f,1.0f,1.0f),
							Vec3(0.0f,1.0f,1.0f),
							Vec3(1.0f,0.0f,1.0f),

							Vec3(0.0f,0.0f,1.0f),
							Vec3(1.0f,0.0f,1.0f),
							Vec3(0.0f,1.0f,1.0f),
							Vec3(1.0f,1.0f,1.0f),
							Vec3(0.0f,1.0f,1.0f),
							Vec3(1.0f,0.0f,1.0f),

							Vec3(0.0f,0.0f,1.0f),
							Vec3(1.0f,0.0f,1.0f),
							Vec3(0.0f,1.0f,1.0f),
							Vec3(1.0f,1.0f,1.0f),
							Vec3(0.0f,1.0f,1.0f),
							Vec3(1.0f,0.0f,1.0f) };

Vec4 colours[NUM_VERTS] = {	Vec3(1.0f,1.0f,1.0f),
							Vec3(1.0f,1.0f,1.0f),
							Vec3(1.0f,1.0f,1.0f),
							Vec3(1.0f,1.0f,1.0f),
							Vec3(1.0f,1.0f,1.0f),
							Vec3(1.0f,1.0f,1.0f),

							Vec3(1.0f,1.0f,1.0f),
							Vec3(1.0f,1.0f,1.0f),
							Vec3(1.0f,1.0f,1.0f),
							Vec3(1.0f,1.0f,1.0f),
							Vec3(1.0f,1.0f,1.0f),
							Vec3(1.0f,1.0f,1.0f),

							Vec3(1.0f,1.0f,1.0f),
							Vec3(1.0f,1.0f,1.0f),
							Vec3(1.0f,1.0f,1.0f),
							Vec3(1.0f,1.0f,1.0f),
							Vec3(1.0f,1.0f,1.0f),
							Vec3(1.0f,1.0f,1.0f),

							Vec3(1.0f,1.0f,1.0f),
							Vec3(1.0f,1.0f,1.0f),
							Vec3(1.0f,1.0f,1.0f),
							Vec3(1.0f,1.0f,1.0f),
							Vec3(1.0f,1.0f,1.0f),
							Vec3(1.0f,1.0f,1.0f),

							Vec3(1.0f,1.0f,1.0f),
							Vec3(1.0f,1.0f,1.0f),
							Vec3(1.0f,1.0f,1.0f),
							Vec3(1.0f,1.0f,1.0f),
							Vec3(1.0f,1.0f,1.0f),
							Vec3(1.0f,1.0f,1.0f),

							Vec3(1.0f,1.0f,1.0f),
							Vec3(1.0f,1.0f,1.0f),
							Vec3(1.0f,1.0f,1.0f),
							Vec3(1.0f,1.0f,1.0f),
							Vec3(1.0f,1.0f,1.0f),
							Vec3(1.0f,1.0f,1.0f)};


Vec4 verts[NUM_VERTS] = {	Vec3(-0.5f,-0.5f, 0.5f),
							Vec3( 0.5f,-0.5f, 0.5f),
							Vec3(-0.5f, 0.5f, 0.5f),
							Vec3( 0.5f, 0.5f, 0.5f),
							Vec3(-0.5f, 0.5f, 0.5f),
							Vec3( 0.5f,-0.5f, 0.5f),

							Vec3(-0.5f,-0.5f,-0.5f),
							Vec3(-0.5f, 0.5f,-0.5f),
							Vec3( 0.5f,-0.5f,-0.5f),
							Vec3( 0.5f, 0.5f,-0.5f),
							Vec3( 0.5f,-0.5f,-0.5f),
							Vec3(-0.5f, 0.5f,-0.5f),

							Vec3(-0.5f,-0.5f,-0.5f),
							Vec3(-0.5f,-0.5f, 0.5f),
							Vec3(-0.5f, 0.5f,-0.5f),
							Vec3(-0.5f, 0.5f, 0.5f),
							Vec3(-0.5f, 0.5f,-0.5f),
							Vec3(-0.5f,-0.5f, 0.5f),

							Vec3( 0.5f,-0.5f,-0.5f),
							Vec3( 0.5f, 0.5f,-0.5f),
							Vec3( 0.5f,-0.5f, 0.5f),
							Vec3( 0.5f, 0.5f, 0.5f),
							Vec3( 0.5f,-0.5f, 0.5f),
							Vec3( 0.5f, 0.5f,-0.5f),

							Vec3(-0.5f, 0.5f, 0.5f),
							Vec3( 0.5f, 0.5f, 0.5f),
							Vec3(-0.5f, 0.5f,-0.5f),
							Vec3( 0.5f, 0.5f,-0.5f),
							Vec3(-0.5f, 0.5f,-0.5f),
							Vec3( 0.5f, 0.5f, 0.5f),

							Vec3(-0.5f,-0.5f, 0.5f),
							Vec3(-0.5f,-0.5f,-0.5f),
							Vec3( 0.5f,-0.5f, 0.5f),
							Vec3( 0.5f,-0.5f,-0.5f),
							Vec3( 0.5f,-0.5f, 0.5f),
							Vec3(-0.5f,-0.5f,-0.5f) };
